/*
 * Estrutura:
 * Retangulos: 0..MAXRETANGULOS
 *             Point
 * Arestas   : 0..MAXARESTAS
 *  
 * Point: int x, int y
 */



import java.awt.*;
import java.applet.*;
import java.awt.event.*;
  
public class Inicia extends Applet implements ActionListener, ItemListener {

 final static int steps = 4;
 final static int DELAY = 10;

 public  Image offscreen = null;
 private AreaDesenho areadesenho = new AreaDesenho(this);
   

 // Object -+- Component -+- <Container> -+- Panel - Applet
 //         |             |               |
 //         .             .               +- Window -+- Dialog - FileDialog
 //         .             .                          |
 //         .             .                          +- Frame
 //
 //Frame JanelaPrincipal;
 //Window JanelaPrincipal;
 Container janelaPrincipal;   

 CheckboxGroup ck_objeto = new CheckboxGroup();
 Checkbox ck_quadrado,
          ck_aresta;

 private boolean eh_applet = false;
 Color corFundo = new Color(150, 200, 250);
 private painelInf p_inf = new painelInf();

 public void msg(String msg) {
   p_inf.msg.setText(msg);
   }

 private void Retardo( ) {
   try {
     Thread.sleep(steps * DELAY);
     } catch (InterruptedException ie) { }
   }

 // Ao: clique nos itens tipo Checkbox
 public void itemStateChanged(ItemEvent e) {
   if (e.getStateChange() == ItemEvent.DESELECTED)
       return;
   if (e.getItem().equals(areadesenho.S_RETANGULO)) {
      msg("Clique na rea de desenho para criar vrtices tipo quadrado                 ");
      //System.out.println("Clique na rea de desenho para criar vrtices tipo quadrado                 ");
      }
   else {
      msg("Clique no primeiro vrtice para criar aresta                                ");
      //System.out.println("Clique no primeiro vrtice para criar aresta                                ");
      }

   //    if (e.getItem().equals("Small"))
   }

 public void actionPerformed(ActionEvent e) {
   String s = e.getActionCommand();
   if ( s.equals ("Limpa") ) {
      areadesenho.Limpa();
   
      //Checkbox ck = 
      ck_objeto.setSelectedCheckbox( ck_quadrado );
      msg("Clique na rea de desenho para criar vrtices tipo quadrado                 ");
      areadesenho.repaint();
      }
   else
   if ( s.equals ("Fim") ) {
      //janelaPrincipal.dispose();
      if ( ! eh_applet ) System.exit(0);
      else ((Applet)janelaPrincipal).destroy(); //janelaPrincipal.dispose();//dispose();
      }
   else
   if ( s.equals ("rv.") ) {
      //areadesenho.geraArvoreBinaria();
      }
   else
   if ( s.equals ("Imp") ) {
      areadesenho.imprimeMatriz();
      }
   }


 public Inicia () {
   }
   
 // Separado do construtor para poder tratar aps a instanciao se ser Applet ou Frame
 public void montaJanela () {

     Panel  p = new Panel(), p1 = new Panel(), p2 = new Panel();
     Button b_limpa  = new Button("Limpa"),
            b_fim    = new Button("Fim"),
            b_grava  = new Button("rv."),
            b_imp    = new Button("Imp");

     b_limpa.addActionListener(this);
     b_fim.addActionListener(this);
     b_grava.addActionListener(this);
     b_imp.addActionListener(this);

     Checkbox ck;
     p2.add( ck_quadrado = new Checkbox("Retngulo"));
     ck_quadrado.setCheckboxGroup( ck_objeto );         // acrescenta no grupo excludente de tiquetes
     ck_quadrado.addItemListener(this);                 // ouvidor p/ tratar clique em quadrado
     ck_objeto.setSelectedCheckbox( ck_quadrado );
     p2.add( ck_aresta = new Checkbox("Aresta"));
     ck_aresta.setCheckboxGroup( ck_objeto );
     ck_aresta.addItemListener(this);                   // ouvidor p/ tratar clique em quadrado

     p.setLayout(new BorderLayout());
     
     p1.add(b_limpa); p1.add(b_grava);
     //p1.add(b_imp); // imp para teste: imprime matriz de adj.

     ck_objeto.setSelectedCheckbox( ck_quadrado );
     msg("Clique na rea de desenho para criar vrtices tipo quadrado                 ");
     areadesenho.repaint();
     //areadesenho.Desenha( );// offscreen ); //Graphics g ){     

     if (!eh_applet) {
	 janelaPrincipal = new Frame();
         ((Frame)janelaPrincipal).addWindowListener(new WindowAdapter() {
	                 public void windowClosing(WindowEvent e) { System.exit(0); }
                         } );
	  p1.add(b_fim); 
     }
     else janelaPrincipal = this; // recebe o "applet" atual (no abrir nova janela)
     p.add(p1,"North"); p.add(p2,"South");

	 this.janelaPrincipal = janelaPrincipal;
    
         janelaPrincipal.setBackground(corFundo);
         janelaPrincipal.setLayout(new BorderLayout());//setLayout(new BorderLayout()); //
 
         janelaPrincipal.add(p,"North");//this.add(p,"North"); //
         janelaPrincipal.add(areadesenho,"Center"); // com "South" no aparece!!//
         janelaPrincipal.add( p_inf,"South");
         janelaPrincipal.setSize(550,600);//
         janelaPrincipal.setVisible(true);//     this.setVisible(true);//
     }

 // Constri janela dentro do "Applet"
 public void init() {
   eh_applet = true;
   this.montaJanela();
   }

 // Constri janela num "Frame"
 public static void main(String[] args) {
     Inicia imp = new Inicia();
     imp.montaJanela();    
     }

}
